#!/usr/bin/perl 

use strict;

# This will take in a fasta file, and convert it to a clustalw alignment file, the outputfile
# This will be used when using Muscle to do the profile alignments...

use Bio::AlignIO;
use Bio::SeqIO;
use Bio::LocatableSeq;


#read in the initial alignment from the command line.

my $seqfile = $ARGV[0];
my $outputfile = $ARGV[1];

#set up initial alignment.....
my $input = new Bio::SeqIO->new(
                               -file => $seqfile);

my $output = Bio::AlignIO->new(-file=> '>'.$outputfile, '-format' => 'clustalw');

my $Align=new Bio::SimpleAlign();


while ( my $seq = $input->next_seq() ) {
   my $newseq = new Bio::LocatableSeq(-seq => $seq->seq,
                                    -id  => $seq->id,
                                    -start => 1,
                                    -end   => length($seq->seq));
#        print "adding id:\t",$seq->id,"\n";
     	$Align->add_seq($newseq);
	}


if( $Align->is_flush() ){
$output->write_aln($Align);
RemoveNumbers($outputfile);
}else { print "\n\nERROR creating $outputfile\n\n" }



sub RemoveNumbers(){
#This function will remove numbers in the name  generated by bioperl...

my $file=$_[0];
open(FILE,$file);
open(TMP,">tmpoutfile");

while(<FILE>){
      s/\/1-\d+//;
      print  TMP $_;
}

close(FILE);
close(TMP);
system("mv tmpoutfile $file");
}

