#!/usr/bin/perl 

use strict;

# This will extract the sequences from a clustalw file and create a file called "sequences" used by SAGA
# This will be used when using Muscle to do the profile alignments...

use Bio::AlignIO;
use Bio::SeqIO;
use Bio::LocatableSeq;


#read in the initial alignment from the command line.

my $seqfile = "sequences";
my $outputfile = $ARGV[0];

my $output = Bio::SeqIO->new(-file=> '>'.$seqfile, '-format' => 'fasta');

my $alignio = Bio::AlignIO->new(-file=> $outputfile, '-format' => 'clustalw');

	my $aln = $alignio->next_aln;
   	$aln->sort_alphabetically;
   	
	foreach my $seq($aln->each_seq){
        #print "adding id:\t",$seq->id,"\n";
        my $newseq=$seq->seq;
        $newseq=~ s/-//g;
	$seq->seq($newseq);
	$output->write_seq( $seq);
	}

