#!/usr/bin/perl 
#Main function for the iterative improvement of clustalw . 
#Takes the alignment input

use Bio::AlignIO;

#read in the initial alignment from the command line.

$alignment = $ARGV[0];

system("cp $alignment test.aln");
if(-e "sequences"){ system("rm sequences");}
system("./extractseq.pl test.aln");
SagaScore();
print "\nStarting score is $CurrentScore\n";
$maxscore=$CurrentScore;

$score=$maxscore;

system("cp $alignment best.aln\n");
$bestalignment='best.aln';

#set up initial alignment.....
my $startingalignment    = new Bio::AlignIO(-format => 'clustalw',
			       	-file => $alignment);

my $startingaln=$startingalignment->next_aln;


# To print out what is in each Profile
my $numberofseq=$startingaln->no_sequences;
my $iterations=0;
my $counter=0;

while($iterations<2*($startingaln->no_sequences)){
#generate profiles to be aligned
$i=0;
while($i<$startingaln->no_sequences){

@profile1seq=($i);

#print "i: $i\n";
undef @profile2seq; #reset

for($j=0;$j<$startingaln->no_sequences;$j++){
	if($j!=$i){
#	print "j:$j\n";
        @profile2seq=(@profile2seq,$j);
	}
}

#have to load current best alignment,just a file name...



$bestalignment='best.aln';
profilemaker($bestalignment);

#align profiles.
$outfile="$i.iteration";
$outfile1="$i.results";
system("clustalw -profile1=profile1.aln -profile2=profile2.aln -outfile=$outfile > $outfile1\n");
#AlignmentScore($outfile1);

# SAGA scores the test.aln function.....
if (-e test.aln) { system (" rm test.aln");}
system("cp $outfile test.aln");
SagaScore();


#compare to best score and if better replace 
if ($CurrentScore < $maxscore) {
#$percent=(($CurrentScore-$score)/$score)*100;
#print "new score $CurrentScore Old Score $maxscore Orginal $score Percent $percent\n";
$maxscore =$CurrentScore;
system("cp $outfile best.aln\n");
$counter=0;
}
else{
$counter=$counter+1;
}

system("rm $outfile $outfile1\n");

$i=$i+1;
}

#in the iteration loop.....
if($counter>($numberofseq+1)){
printf("exiting .....$counter iterations without improvement\n");
$iterations=2*$numberofseq+1;
}

$iterations=$iterations+1;

}

print "new score $CurrentScore Orginal $score\n";


sub profilemaker(){
#needs these two arrays...	@profile2seq=(0,1,2);
#				@profile1seq=(3,4,5,6);
# code to generate two profiles from one alignment.
# creates two files profile1.aln profile2.aln

use Bio::AlignIO;
use File::Copy;


my $inputfile = $_[0];

my $Align=new Bio::SimpleAlign();
my $Align1=new Bio::SimpleAlign();

my $alignio = new Bio::AlignIO(-format => 'clustalw',
			       -file => $inputfile);

my $profile1 = new Bio::AlignIO->new(-format => 'clustalw',
			       -file => '>profile1.aln');
my $profile2 = new Bio::AlignIO->new(-format => 'clustalw',
			       -file => '>profile2.aln');

my $i;
my $profile1counter;
my $profile2counter;

while( my $aln = $alignio->next_aln ) {
	$i=0;
	$profile1counter=0;
	$profile2counter=0;
         
	foreach my $seq ($aln->each_alphabetically) {
    	
     	if ($i==($profile1seq[$profile1counter])){

     		$Align->add_seq($seq);
                $profile1counter=$profile1counter+1;
		
        	}	
     	if ($i==($profile2seq[$profile2counter])){

     		$Align1->add_seq($seq);
                $profile2counter=$profile2counter+1;
     	
        	}
	$i=$i+1;
     
	}
 # profile1 and profile2 counter have to equal i,the number of sequences, which has to equal.....
my $seq1size=$Align->no_sequences;
my $seq2size=$Align1->no_sequences;
my $total=$seq1size+$seq2size;
                                                                                                                                                             
if($total!=$i){
 print "Error: No of sequences in profiles don't match\n";
}
 
 $profile1->write_aln($Align);
 $profile2->write_aln($Align1);
 
 
}


# To print out what is in each Profile
#	print "in the first profile\n";
#	foreach my $seq ($Align->each_seq) {
#        print "\t '", $seq->display_id(), "'\n";
#	}
#	print "in the second profile\n";
#	foreach my $seq ($Align1->each_seq) {
#        print "\t '", $seq->display_id(), "'\n";
#	}


filtering('profile1.aln', '>out1.aln');
filtering('profile2.aln', '>out2.aln');

move('out1.aln','profile1.aln');
move('out2.aln','profile2.aln');

}

#start of fuctionfiltering file

sub filtering(){

#function to eliminate columns that just contain gaps.....
#pass the filename containing the profile to be cleaned,and the output filename.
#filtering('profile1.aln', '>out.aln');
use Bio::AlignIO;

$withgaps=$_[0];
$withoutgaps=$_[1];

my $in = new Bio::AlignIO ( -file => $withgaps, -format => 'clustalw' );
my $out = new Bio::AlignIO ( -file => $withoutgaps, -format => 'clustalw' );

my $aln = $in->next_aln();

# if you need to work on the columns, create a list containing all columns as 
# strings 

my @aln_cols = ();

foreach my $seq ( $aln->each_alphabetically() ) {
  my $colnr = 0;    
  foreach my $chr ( split("", $seq->seq()) ) {	
    $aln_cols[$colnr] .= $chr;
    $colnr++;   
  }
}

# then do the work:
# we want to eliminate all the columns containing gaps
# 1/ we create a list containing all the columns without any gap

my $gapchar = $aln->gap_char();
my @no_gap_cols = ();
foreach my $col ( @aln_cols ) {
 my $columnlength = length($col);
 next if $col =~ /\Q$gapchar\E{$columnlength}/;    
 push @no_gap_cols, $col;
}

# 2/  we modify the sequences in the alignment
# 2a/ we reconstruct the sequence strings

my @seq_strs = ();
foreach my $col ( @no_gap_cols ) {
   my $colnr = 0;    
   foreach my $chr ( split"", $col ) {
     $seq_strs[$colnr] .= $chr;	
     $colnr++;    }}

# 2b/ we replace the old sequences strings with the new ones
foreach my $seq ( $aln->each_alphabetically() ) {    
    $seq->seq(shift @seq_strs);}

$out->write_aln($aln);
}

sub AlignmentScore(){
#!/usr/bin/perl 

$file=$_[0];
open(RESULTS,$file) or die;

while(<RESULTS>){
	if(/Alignment Score ([0123456789\-]+)/){
    	$CurrentScore=$1;
	}
}

close(RESULTS);
}


sub SagaScore(){
        if (-e "saga.sparam"){
		system("./removenumbers.pl test.aln");
                system("saga s: saga.sparam ");
                ReadSagaScore("test.saga_aln");
                system("rm test.saga_aln");
        } else { die "could not find saga.sparam" }

}

sub ReadSagaScore(){
#Will read the saga score from the output file....


$file=$_[0];
open(RESULTS,$file) or die "could not open $file\n";


        while(<RESULTS>){
         if(/Score= (\d+)/){
#    print $_;
         $CurrentScore=$1;
                }
        }
}

